<script setup lang="ts">
const activeTab = ref(0);
const {
  assignHashText,
  promotions,
  promotionGroup,
  onClickPromotion,
  isLoading,
  promotionListForDisplay,
  checkPromotionGroup,
  buttonApplyPromotionEnabled,
  authenticated,
  onApplyPromotion,
  isProcessing,
  applyRequest,
  onClickSpinNow,
  validateLuckyWheelbutton,
} = usePromotion();
</script>

<template>
  <promotion-type
    v-loading="isLoading"
    :menu="'top'"
    class="container grid gap-5 mx-auto my-5"
  >
    <template v-slot:category>
      <div class="mx-auto container rounded">
        <el-menu
          :default-active="activeTab"
          class="w-full border-0 el-menu-demo"
          mode="horizontal"
          text-color="var(--text)"
          active-text-color="var(--secondary)"
          background-color="var(--background1)"
        >
          <el-menu-item
            v-for="(promoGroup, index) in promotionGroup"
            :key="index"
            :index="index"
          >
            <span
              class="cursor-pointer nav-main-cont w-full h-full px-[20px]"
              @click="onClickPromotion(promoGroup.label)"
            >
              {{ promoGroup.Type }}
            </span>
          </el-menu-item>
        </el-menu>
      </div>
    </template>
    <template v-slot:content>
      <div>
        <div v-for="(promotion, index) in promotionListForDisplay" :key="index">
          <promotion-horizontal-card
            :key="promotion.Id"
            :check-promotion-group="checkPromotionGroup"
            :is-hover-scale-center="true"
            :promotion="promotion"
            :button-apply-promotion-enabled="buttonApplyPromotionEnabled"
            :authenticated="authenticated"
            :on-apply-promotion="onApplyPromotion"
            :is-processing="isProcessing"
            :is-applying="applyRequest.PromotionId === promotion.Id"
            :on-click-spin-now="onClickSpinNow"
            :validateLuckyWheelbutton="validateLuckyWheelbutton(promotion)"
          />
        </div>
        <div
          v-if="promotions.length === 0 || promotionListForDisplay.length === 0"
          class="flex flex-col justify-center items-center my-[60px] col-span-3 overflow-hidden"
        >
          <div class="text-4xl text-center truncate no-data text-ellipsis">
            {{ $t("no_promotion_info") }}
          </div>
          <span class="font-bold text-lg fc-text">{{ assignHashText }}</span>
        </div>
      </div>
    </template>
  </promotion-type>
</template>

<style scoped>
:deep(.el-menu-item) {
  padding: 0;
}
:deep(.el-menu--horizontal) {
  border-radius: 8px;
}
:deep(.el-menu--horizontal .el-menu-item:not(.is-disabled):focus) {
  background: var(--background1);
}
:deep(.el-menu--horizontal .el-menu-item:not(.is-disabled):hover) {
  background: var(--background1);
}
</style>
